# FAQ — часто задаваемые вопросы

Здесь представлены наиболее частые вопросы и проблемы, с которыми сталкиваются пользователи.

### Как подключить устройство/эмулятор с помощью ADB

Если таск **Configure ADB** не то что вы искали, попробуйте изучить <https://developer.android.com/studio/command-line/adb>.

### Я не могу найти отправленное местоположение

Проверьте свойство `pushTo` ваших конфигураций, возможно оно содержит неправильный путь. Также, убедитесь что процесс сборки прошел без ошибок.

### Variable `${fileWorkspaceFolder}` can not be resolved. Please open an editor

Один из наиболее простых и удобных путей найти папку с которой вы взаимодействуете, открыть любой файл и проверить где она находится для поиска проекта. По умолчанию используется последняя открытая папка, если она не существует, вам будет предложено создать новый проект.

### Project 'toolchain_<хеш>' is missing required source folder: '_/<имя_папки>/java/<модуль>/src'

Все пути в мульти-корневом пространстве становятся относительными, однако, папки вне основной *toolchain/* локации конвертируются из корневых (../) в безопасные для расширения (_/). Эта ошибка не обязана быть исправлена если вы собираете проект через тулчейн, самый простой способ избавиться от этой ошибки это переместить проект в подпапку тулчейна где он и должен быть или изменить настройки вашей среды, вручную добавив нужные пути вместо использования *.classpath*.

## Проблемы с которыми можно столкнуться в терминале

### npm: command not found

<https://nodejs.org/en/download/package-manager/>

### unsupported class file version 55.0

Компилятор дексов андроида требует JDK 8 (идентификатор 1.8). Установите его по умолчанию если необходимо, либо проделайте небольшую работу по установке значений в среде:

- IntelliJ:

1. Откройте `File` > `Project Structure` > `Project`
2. Выберите `Project SDK`
3. Используйте java8 или что-то вроде того
4. Примените изменения

- VSCode:

1. Откройте Explorer (*Ctrl+Shift+E*)
2. Найдите вкладку Java Projects, включите ее в `Views and More Actions...` если нужно
3. Откройте `More Actions...` > `Configure Java Runtime`
4. Измените Java Version на необходимую

### ./gradlew: Permission denied

По какой-то неизвестной причине, ваш *gradlew* файл не имеет флага для исполнения. Откройте папку `toolchain/toolchain/bin/gradle` в терминале и выполните `chmod +x gradlew`.

### error trying to exec 'cc1plus': execvp: No such file or directory

После загрузки и распаковки NDK, флаг исполнения был потерян и операционная система не разрешает его запуск. Загрузите и установите NDK вручную или просто выполните `chmod -R +x *` в открытой в терминале папке `toolchain/ndk/<требуемая-архитектура>` ваших GCC.

> Статья будет пополняться по мере появления новых проблем и неточностей.
